/*******************************************************************************************
* Version: human_car_parsing_v0.0.0
* CopyRight: пԺԶоģʽʶʵͼƵ
* UpdateDate: 20190402
* Content: ﳵ
********************************************************************************************/

#ifndef HUMANCARPARSING_H_
#define HUMANCARPARSING_H_

#ifdef _MSC_VER
#ifdef HUMANCARPARSING_EXPORTS
#define HUMANCARPARSING_API __declspec(dllexport)
#else
#define HUMANCARPARSING_API __declspec(dllimport)
#endif
#else
#define HUMANCARPARSING_API   __attribute__ ((visibility ("default")))
#endif

#include "sy_common.h"

#ifdef __cplusplus
extern "C"
{
#endif

#ifndef __CLASSIFY_OBJ_RESULT__
#define __CLASSIFY_OBJ_RESULT__
	typedef struct classify_obj_res         //ṹ
	{
		int res_index;              //
		float res_prob;             //ṹ
		classify_obj_res() : res_index(0), res_prob(0) {};
	} classify_obj_res;
#endif

#ifndef __HCF_FEA_RES__
#define __HCF_FEA_RES__
const int HCF_FEATURE_SIZE = 1280;
#endif

#ifndef __HCP_RESULT__
#define __HCP_RESULT__
const int HCP_ATTRI_INDEX_SIZE = 14;
typedef struct hcp_analysis_result
{
	classify_obj_res res_objs[HCP_ATTRI_INDEX_SIZE];          //
	float feature[HCF_FEATURE_SIZE]; //ﳵ
} hcp_analysis_result;
#endif

#ifndef __HCP_PARAM__
#define __HCP_PARAM__
	typedef struct hcp_param
	{
		int mode;				//ģʽ(DEVICE_GPU / DEVICE_CPU)
		int gpuid;              //ָԿid
    int engine;     //ָ(ENGINE_MCAFFE2 / ENGINE_TENSORRT)
    int max_batch;     //ָtrtbatch
		char* serialize_file;
		hcp_param() :mode(DEVICE_GPU), gpuid(0) {};
	}hcp_param;
#endif

	/*************************************************************************
	* FUNCTION: hcp_init
	* PURPOSE: ʼ
	* PARAM:
	[out] tools		   - 
	[in]  param    - ʼ
	* RETURN:
	[out] int             - ʼǷɹSUCCEEDEDʾɹFAILEDʾʧܣ
	* NOTES:
	*************************************************************************/
	HUMANCARPARSING_API int hcp_init(void ** handle, hcp_param param);

	/*************************************************************************
	* FUNCTION: hcp_process
	* PURPOSE: ﳵԼ
	* PARAM:
	[in] tools		      - 
	[in] img_data          - ͼ
	[in] result           - 
	* RETURN:
	[out] int             - ǷɹSUCCEEDEDʾɹFAILEDʾʧܣ
	* NOTES:
	*************************************************************************/
	HUMANCARPARSING_API int hcp_process(void * handle, sy_img img_data, hcp_analysis_result * result);

	/*************************************************************************
	* FUNCTION: hcp_batch
	* PURPOSE: ﳵԼ
	* PARAM:
	[in] tools		      - 
	[in] img_data_array       - ͼ
	[in] batch_size        - ͼĿ
	[in] result           - 
	* RETURN:
	[out] int             - ǷɹSUCCEEDEDʾɹFAILEDʾʧܣ
	* NOTES:
	*************************************************************************/
	HUMANCARPARSING_API int hcp_batch(void * handle, sy_img * img_data_array, int batch_size, hcp_analysis_result * result);


	/*************************************************************************
	* FUNCTION: hcp_release
	* PURPOSE: Դͷ
	* PARAM:
	[in] tools		    - 
	* RETURN:	NULL
	* NOTES:
	*************************************************************************/
	HUMANCARPARSING_API void hcp_release(void ** handle);

	/*************************************************************************
	* FUNCTION: hcp_get_version
	* PURPOSE:
	* PARAM:	NULL
	* RETURN:	汾
	* NOTES:
	*************************************************************************/
	HUMANCARPARSING_API const char * hcp_get_version();

#ifdef __cplusplus
};
#endif

#endif
